from socket import *
import os
import subprocess
import copy

addr = ("", 80)

# cache a list of all the real files we can serve
server_root = "public"
files = os.listdir(server_root)

# get rid of the hostname from URLs
def url_split(url):
  if(url.find("//") > -1):
    url = url[url.find("//")+2:]
    url = url[url.find("/"):]
  return url

# do a basic translation of file extension to mime type
def magic_mime(filename):
  e = os.path.splitext(filename)[1].lower()
  if e in [".html", ".htm"]:
    return "text/html"
  elif e == ".xml":
    return "application/xml"
  elif e in [".jpeg", ".jpg"]:
    return "image/jpeg"
  elif e == ".png":
    return "image/png"
  elif e == ".css":
    return "text/css"
  elif e == ".js":
    return "text/javascript"
  else:
    return "text/plain"

# convert a URL encoded post form response to a python dict
def post2dict(pkt):
  ret = {}
  for item in pkt.split("&"):
    val2 = ""
    key,val = item.split("=")
    val = val.replace("+", " ")
    i = 0
    while i < len(val):
      if val[i] == "%":
        val2 += chr(int(val[i+1:i+3], 16))
        i += 3
      else:
        val2 += val[i]
        i += 1
    ret[key] = val2
  return ret

# main listener function
def listener():
  # dummy subprocess to make the variable pr 
  # global and a finished process
  pr = subprocess.Popen(["echo", "nothing"])
  code = ""

  # set up the socket to listen to and bind to it
  TCPSock = socket(AF_INET, SOCK_STREAM)
  TCPSock.bind(addr)
  TCPSock.listen(1)

  # wait for connections indefinitely
  while 1:
    (conn, ad2)=TCPSock.accept()
    pkt = conn.recv(2048)
    lines = pkt.splitlines()
    hfields = {}
    method, uri, ver = lines[0].split()
    pkt = pkt[len(lines[0]):].lstrip()
    # do header
    while 1:
      nl = pkt.find("\r\n")
      if nl == -1:
        pkt = pkt + conn.recv(2048)
      else:
        line = pkt[:nl]
        if line.strip() == "":
          pkt = pkt[nl+2:]
          break
        else:
          hfields[line.split(":")[0].strip()] = line.split(":",1)[1].strip()
          pkt = pkt[nl+2:]

    # receive content e.g. form data
    if "Content-Length" in hfields.keys():
      while len(pkt) < int(hfields["Content-Length"]):
        pkt += conn.recv(2048)

#    print method, uri, url_split(uri)
#    print hfields
#
#    print "=" * 80 + "\n" + pkt + "\n" + "=" * 80

    # handle the request based on URL
    if url_split(uri) == "/run":
      if pr.poll() != None:
        if method == "POST":
          fields = post2dict(pkt)
          fw = file("temp.logo", "w")
          fw.write(fields['code'])
          fw.close()
          code = copy.copy(fields['code'])
          pr = subprocess.Popen(["/usr/bin/python", "logo_interp.py", "temp.logo"])
        else:
          response = "HTTP/1.1 301 FOUND\r\n"
          response += "Location: /\r\n\r\n"

      if pr.poll() == None:
        fr = file("running.html", "r")
        content = fr.read()
        fr.close()
        response = "HTTP/1.1 200 OK\r\n"
        response += "Content-Type: text/html\r\n"
        response += "Content-Length: %d\r\n\r\n" % len(content)
        response += content
    elif url_split(uri).lstrip("/") in files:
      # requested an actual file in the server directory
      fr = file(os.path.join(server_root, url_split(uri).lstrip("/")), "r")
      content = fr.read()
      fr.close()
      response = "HTTP/1.1 200 OK\r\n"
      response += "Content-Type: %s\r\n" % magic_mime(url_split(uri.lstrip("/")))
      response += "Content-Length: %d\r\n\r\n" % len(content)
      response += content
    
    elif url_split(uri) == "/":
      # requested index.html
      fr = file(os.path.join(server_root, "index.html"), "r")
      content = fr.read()
      fr.close()
      response = "HTTP/1.1 200 OK\r\n"
      response += "Content-Type: text/html\r\n"
      response += "Content-Length: %d\r\n\r\n" % len(content.replace("%CODE%", code))
      response += content.replace("%CODE%", code)

    else:
      # return a 404
      content = """<!DOCTYPE html>
<html>
  <head>
    <title>404 Page not found</title>
  </head>
  <body>
    <h1>404: Page Not Found</h1>
  </body>
</html>"""
      response = "HTTP/1.1 404 Not Found\r\n"
      response += "Content-Type: text/html\r\n"
      response += "Content-Length: %d\r\n\r\n" % len(content)
      response += content

    conn.send(response)
    conn.close()

if __name__ == "__main__":
  listener()

